diff --git a/po/POTFILES.in b/po/POTFILES.in
index a752399..0d220b3 100644
--- a/po/POTFILES.in
+++ b/po/POTFILES.in
@@ -6,6 +6,7 @@ nm-connection-editor.desktop.in
 src/applet-dbus-manager.c
 src/applet-device-cdma.c
 src/applet-device-gsm.c
+src/applet-device-modem.c
 src/applet-device-wired.c
 src/applet-device-wifi.c
 src/applet-dialogs.c
@@ -17,6 +18,7 @@ src/connection-editor/ce-page.c
 src/connection-editor/ce-page-dsl.glade
 src/connection-editor/ce-page-ip4.glade
 src/connection-editor/ce-page-mobile.glade
+src/connection-editor/ce-page-modem.glade
 src/connection-editor/ce-page-ppp.glade
 src/connection-editor/ce-page-wired.glade
 src/connection-editor/ce-page-wireless.glade
@@ -27,6 +29,7 @@ src/connection-editor/mobile-wizard.c
 src/connection-editor/page-dsl.c
 src/connection-editor/page-ip4.c
 src/connection-editor/page-mobile.c
+src/connection-editor/page-modem.c
 src/connection-editor/page-ppp.c
 src/connection-editor/page-vpn.c
 src/connection-editor/page-wired.c
diff --git a/src/Makefile.am b/src/Makefile.am
index ff13af9..1f839e1 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -44,6 +44,8 @@ nm_applet_SOURCES =			\
 	applet-device-wired.c \
 	applet-device-wifi.h \
 	applet-device-wifi.c \
+	applet-device-modem.h \
+	applet-device-modem.c \
 	ap-menu-item.h \
 	ap-menu-item.c \
 	applet-device-gsm.h \
diff --git a/src/applet-device-modem.c b/src/applet-device-modem.c
new file mode 100644
index 0000000..aa95f73
--- /dev/null
+++ b/src/applet-device-modem.c
@@ -0,0 +1,611 @@
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* NetworkManager Wireless Applet -- Display wireless access points and allow user control
+ *
+ * Dan Williams <dcbw@redhat.com>
+ * Hans Petter Jansson <hpj@novell.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * (C) Copyright 2008 Red Hat, Inc.
+ * (C) Copyright 2010 Novell, Inc.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <glib/gi18n.h>
+#include <gtk/gtk.h>
+
+#include <nm-device.h>
+#include <nm-setting-connection.h>
+#include <nm-setting-analog-modem.h>
+#include <nm-setting-ip4-config.h>
+#include <nm-setting-serial.h>
+#include <nm-setting-ppp.h>
+#include <nm-device-analog-modem.h>
+#include <nm-utils.h>
+
+#ifdef NO_POLKIT_GNOME
+#include "polkit-gnome.h"
+#else
+#include <polkit-gnome/polkit-gnome.h>
+#endif
+
+#include "applet.h"
+#include "applet-device-modem.h"
+#include "utils.h"
+#include "applet-polkit-manager.h"
+#include "applet-menu-item.h"
+
+typedef struct {
+	NMApplet *applet;
+	NMDevice *device;
+	NMConnection *connection;
+	PolKitGnomeAction *pk_gnome_action;
+} ModemMenuItemInfo;
+
+static void
+modem_menu_item_info_destroy (gpointer data)
+{
+	ModemMenuItemInfo *info = (ModemMenuItemInfo *) data;
+	if (info->device) {
+	    g_object_unref (G_OBJECT (info->device));
+	    info->device = NULL;
+	}
+	if (info->connection) {
+	    g_object_unref (G_OBJECT (info->connection));
+	    info->connection = NULL;
+	}
+	if (info->pk_gnome_action) {
+	    g_object_unref (G_OBJECT (info->pk_gnome_action));
+	    info->pk_gnome_action = NULL;
+	}
+
+	g_slice_free (ModemMenuItemInfo, data);
+}
+
+#define DEFAULT_MODEM_NAME _("Auto Modem connection")
+
+static NMConnection *
+modem_new_auto_connection (NMDevice *device,
+                          NMApplet *applet,
+                          gpointer user_data)
+{
+	NMConnection *connection;
+	NMSettingAnalogModem *s_modem;
+	NMSettingSerial *s_serial;
+	NMSettingPPP *s_ppp;
+	NMSettingConnection *s_con;
+	char *uuid;
+
+	connection = nm_connection_new ();
+
+	s_modem = NM_SETTING_ANALOG_MODEM (nm_setting_analog_modem_new ());
+
+	nm_connection_add_setting (connection, NM_SETTING (s_modem));
+
+	/* Serial setting */
+	s_serial = (NMSettingSerial *) nm_setting_serial_new ();
+	g_object_set (s_serial,
+	              NM_SETTING_SERIAL_BAUD, 115200,
+	              NM_SETTING_SERIAL_BITS, 8,
+	              NM_SETTING_SERIAL_PARITY, 'n',
+	              NM_SETTING_SERIAL_STOPBITS, 1,
+	              NULL);
+
+	nm_connection_add_setting (connection, NM_SETTING (s_serial));
+
+	s_ppp = (NMSettingPPP *) nm_setting_ppp_new ();
+	nm_connection_add_setting (connection, NM_SETTING (s_ppp));
+
+	s_con = NM_SETTING_CONNECTION (nm_setting_connection_new ());
+	uuid = nm_utils_uuid_generate ();
+	g_object_set (s_con,
+		      NM_SETTING_CONNECTION_ID, DEFAULT_MODEM_NAME,
+		      NM_SETTING_CONNECTION_TYPE, nm_setting_get_name (NM_SETTING (s_modem)),
+		      NM_SETTING_CONNECTION_AUTOCONNECT, FALSE,
+		      NM_SETTING_CONNECTION_UUID, uuid,
+		      NULL);
+	g_free (uuid);
+	nm_connection_add_setting (connection, NM_SETTING (s_con));
+
+	return connection;
+}
+
+static void
+modem_menu_item_activate (GtkMenuItem *item, gpointer user_data)
+{
+	ModemMenuItemInfo *info = (ModemMenuItemInfo *) user_data;
+
+	applet_menu_item_activate_helper (info->device,
+	                                  info->connection,
+	                                  "/",
+	                                  info->applet,
+	                                  user_data);
+}
+
+static void
+add_connection_items (NMDevice *device,
+                      GSList *connections,
+                      NMConnection *active,
+                      GtkWidget *menu,
+                      NMApplet *applet)
+{
+	GSList *iter;
+	ModemMenuItemInfo *info;
+	AppletPolKitManager * pk_manager;
+	pk_manager = applet_polkit_manager_get ();
+
+	for (iter = connections; iter; iter = g_slist_next (iter)) {
+		NMConnection *connection = NM_CONNECTION (iter->data);
+		NMSettingConnection *s_con;
+		GtkWidget *item;
+		PolKitGnomeAction * pk_gnome_action;
+		const char * connection_type;
+
+		pk_gnome_action = NULL;
+
+		s_con = NM_SETTING_CONNECTION (nm_connection_get_setting (connection, NM_TYPE_SETTING_CONNECTION));
+		connection_type = s_con ? nm_setting_connection_get_connection_type (s_con) : NULL;
+		if (connection_type == NULL) {
+			g_warning ("connection_type is NULL");
+			continue;
+		}
+
+		item = applet_menu_item_new_with_label (nm_setting_connection_get_id (s_con));
+		gtk_check_menu_item_set_draw_as_radio (GTK_CHECK_MENU_ITEM (item), TRUE);
+
+		if (connection == active)
+			gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (item), TRUE);
+
+		if (!is_system_connection (connection)) {
+		    NMSettingIP4Config *s_ip4;
+		    AppletPolKitManagerActionDetails action_details;
+
+		    action_details = APPLET_POLKIT_MANAGER_ACTION_CONNECTION_TYPE;
+		    s_ip4 = NM_SETTING_IP4_CONFIG (nm_connection_get_setting (connection, NM_TYPE_SETTING_IP4_CONFIG));
+		    if (s_ip4) {
+			const char *ip4_method;
+			ip4_method = nm_setting_ip4_config_get_method (s_ip4);
+			if (!strcmp (ip4_method, "shared")) {
+			    action_details = APPLET_POLKIT_MANAGER_ACTION_CONNECTION_TYPE_WITH_SHARE;
+			}
+		    }
+		    pk_gnome_action = applet_polkit_manager_connect_menu_item_action (pk_manager, APPLET_MENU_ITEM (item), connection_type, action_details);
+		    if (pk_gnome_action == NULL) {
+			g_object_ref (item);
+			gtk_object_sink (GTK_OBJECT (item));
+			gtk_widget_destroy (GTK_WIDGET (item));
+			g_object_unref (item);
+			continue;
+		    }
+		    /* set the applet for item auth end callback in AppletPolKitManager */
+		    g_object_set_data (G_OBJECT (item), "applet", applet);
+		}
+
+		info = g_slice_new0 (ModemMenuItemInfo);
+		info->applet = applet;
+		info->device = g_object_ref (G_OBJECT (device));
+		info->connection = g_object_ref (connection);
+		info->pk_gnome_action = pk_gnome_action;
+
+		g_signal_connect_data (item, "activate",
+		                       G_CALLBACK (modem_menu_item_activate),
+		                       info,
+		                       (GClosureNotify) modem_menu_item_info_destroy, 0);
+
+		gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
+	}
+}
+
+static void
+modem_menu_item_deactivate (GtkMenuItem *item, gpointer user_data)
+{
+	ModemMenuItemInfo *info = (ModemMenuItemInfo *) user_data;
+	NMActiveConnection *active = NULL;
+
+	applet_find_active_connection_for_device (info->device, info->applet, &active);
+	if (active)
+		nm_client_deactivate_connection (info->applet->nm_client, active);
+	else
+		g_warning ("%s: couldn't find active connection to deactive", __func__);
+}
+
+static void
+add_disconnect_item (NMDevice *device,
+                     GtkWidget *menu,
+                     NMApplet *applet)
+{
+	NMDeviceState state;
+	GtkWidget *item;
+	ModemMenuItemInfo *info;
+
+	state = nm_device_get_state (device);
+	if (   state == NM_DEVICE_STATE_UNKNOWN
+	    || state == NM_DEVICE_STATE_UNMANAGED
+	    || state == NM_DEVICE_STATE_UNAVAILABLE
+	    || state == NM_DEVICE_STATE_DISCONNECTED
+	    || state == NM_DEVICE_STATE_FAILED)
+		return;
+
+	item = gtk_menu_item_new_with_label (_("Disconnect"));
+
+	info = g_slice_new0 (ModemMenuItemInfo);
+	info->applet = applet;
+	info->device = g_object_ref (G_OBJECT (device));
+
+	g_signal_connect_data (item, "activate",
+	                       G_CALLBACK (modem_menu_item_deactivate),
+	                       info,
+	                       (GClosureNotify) modem_menu_item_info_destroy, 0);
+
+	gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
+}
+
+static void
+modem_add_menu_item (NMDevice *device,
+                    guint32 n_devices,
+                    NMConnection *active,
+                    GtkWidget *menu,
+                    NMApplet *applet)
+{
+	char *text;
+	GtkWidget *item;
+	GSList *connections, *all;
+	GtkWidget *label;
+	char *bold_text;
+
+	all = applet_get_all_connections (applet);
+	connections = utils_filter_connections_for_device (device, all);
+	g_slist_free (all);
+
+	if (n_devices > 1) {
+		char *desc;
+
+		desc = (char *) utils_get_device_description (device);
+		if (!desc)
+			desc = (char *) nm_device_get_iface (device);
+		g_assert (desc);
+
+		text = g_strdup_printf (_("Dial-up Modem (%s)"), desc);
+	} else {
+		text = g_strdup (_("Dial-up Modem"));
+	}
+
+	item = gtk_menu_item_new_with_label (text);
+	g_free (text);
+
+	label = gtk_bin_get_child (GTK_BIN (item));
+	bold_text = g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",
+	                                     gtk_label_get_text (GTK_LABEL (label)));
+	gtk_label_set_markup (GTK_LABEL (label), bold_text);
+	g_free (bold_text);
+
+	gtk_widget_set_sensitive (item, FALSE);
+	gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
+	gtk_widget_show (item);
+
+	/* Notify user of unmanaged or unavailable device */
+	item = nma_menu_device_check_unusable (device, NULL);
+	if (item) {
+		gtk_menu_shell_append (GTK_MENU_SHELL (menu), item);
+		gtk_widget_show (item);
+		goto out;
+	}
+
+	if (g_slist_length (connections))
+		add_connection_items (device, connections, active, menu, applet);
+	add_disconnect_item (device, menu, applet);
+
+out:
+	g_slist_free (connections);
+}
+
+static void
+modem_device_state_changed (NMDevice *device,
+                           NMDeviceState new_state,
+                           NMDeviceState old_state,
+                           NMDeviceStateReason reason,
+                           NMApplet *applet)
+{
+	if (new_state == NM_DEVICE_STATE_ACTIVATED) {
+		NMConnection *connection;
+		NMSettingConnection *s_con = NULL;
+		char *str = NULL;
+
+		connection = applet_find_active_connection_for_device (device, applet, NULL);
+		if (connection) {
+			const char *id;
+
+			s_con = NM_SETTING_CONNECTION (nm_connection_get_setting (connection, NM_TYPE_SETTING_CONNECTION));
+			id = s_con ? nm_setting_connection_get_id (s_con) : NULL;
+			if (id)
+				str = g_strdup_printf (_("You are now connected to '%s'."), id);
+		}
+
+		applet_do_notify_with_pref (applet,
+		                            _("Connection Established"),
+		                            str ? str : _("You are now connected to the dial-up network."),
+		                            "nm-device-wwan",
+		                            PREF_DISABLE_CONNECTED_NOTIFICATIONS);
+		g_free (str);
+	}
+}
+
+static GdkPixbuf *
+modem_get_icon (NMDevice *device,
+               NMDeviceState state,
+               NMConnection *connection,
+               char **tip,
+               NMApplet *applet)
+{
+	NMSettingConnection *s_con;
+	GdkPixbuf *pixbuf = NULL;
+	const char *id;
+
+	id = nm_device_get_iface (NM_DEVICE (device));
+	if (connection) {
+		s_con = NM_SETTING_CONNECTION (nm_connection_get_setting (connection, NM_TYPE_SETTING_CONNECTION));
+		id = nm_setting_connection_get_id (s_con);
+	}
+
+	switch (state) {
+	case NM_DEVICE_STATE_PREPARE:
+		*tip = g_strdup_printf (_("Preparing dial-up modem connection '%s'..."), id);
+		break;
+	case NM_DEVICE_STATE_CONFIG:
+		*tip = g_strdup_printf (_("Configuring dial-up modem connection '%s'..."), id);
+		break;
+	case NM_DEVICE_STATE_NEED_AUTH:
+		*tip = g_strdup_printf (_("User authentication required for dial-up modem connection '%s'..."), id);
+		break;
+	case NM_DEVICE_STATE_IP_CONFIG:
+		*tip = g_strdup_printf (_("Requesting a network address for '%s'..."), id);
+		break;
+	case NM_DEVICE_STATE_ACTIVATED:
+		pixbuf = applet->modem_icon;
+		*tip = g_strdup_printf (_("Dial-up modem connection '%s' active"), id);
+		break;
+	default:
+		break;
+	}
+
+	return pixbuf;
+}
+
+typedef struct {
+	DBusGMethodInvocation *context;
+	NMApplet *applet;
+	NMConnection *connection;
+	NMActiveConnection *active_connection;
+	GtkWidget *dialog;
+	GtkEntry *secret_entry;
+	char *secret_name;
+} NMModemInfo;
+
+static void
+destroy_modem_dialog (gpointer user_data, GObject *finalized)
+{
+	NMModemInfo *info = user_data;
+
+	gtk_widget_hide (info->dialog);
+	gtk_widget_destroy (info->dialog);
+
+	g_object_unref (info->connection);
+	g_free (info->secret_name);
+	g_free (info);
+}
+
+static void
+get_modem_secrets_cb (GtkDialog *dialog,
+                     gint response,
+                     gpointer user_data)
+{
+	NMModemInfo *info = (NMModemInfo *) user_data;
+	NMAGConfConnection *gconf_connection;
+	NMSettingAnalogModem *setting;
+	GHashTable *settings_hash;
+	GHashTable *secrets;
+	GError *err = NULL;
+
+	/* Got a user response, clear the NMActiveConnection destroy handler for
+	 * this dialog since this function will now take over dialog destruction.
+	 */
+	g_object_weak_unref (G_OBJECT (info->active_connection), destroy_modem_dialog, info);
+
+	if (response != GTK_RESPONSE_OK) {
+		g_set_error (&err, NM_SETTINGS_ERROR, NM_SETTINGS_ERROR_SECRETS_REQUEST_CANCELED,
+		             "%s.%d (%s): canceled",
+		             __FILE__, __LINE__, __func__);
+		goto done;
+	}
+
+	setting = NM_SETTING_ANALOG_MODEM (nm_connection_get_setting (info->connection, NM_TYPE_SETTING_ANALOG_MODEM));
+
+	if (!strcmp (info->secret_name, NM_SETTING_ANALOG_MODEM_PASSWORD)) {
+		g_object_set (setting,
+			      NM_SETTING_ANALOG_MODEM_PASSWORD, gtk_entry_get_text (info->secret_entry),
+			      NULL);
+	}
+
+	secrets = nm_setting_to_hash (NM_SETTING (setting));
+	if (!secrets) {
+		g_set_error (&err, NM_SETTINGS_ERROR, NM_SETTINGS_ERROR_INTERNAL_ERROR,
+				   "%s.%d (%s): failed to hash setting '%s'.",
+			     __FILE__, __LINE__, __func__, nm_setting_get_name (NM_SETTING (setting)));
+		goto done;
+	}
+
+	/* Returned secrets are a{sa{sv}}; this is the outer a{s...} hash that
+	 * will contain all the individual settings hashes.
+	 */
+	settings_hash = g_hash_table_new_full (g_str_hash, g_str_equal,
+								    g_free, (GDestroyNotify) g_hash_table_destroy);
+
+	g_hash_table_insert (settings_hash, g_strdup (nm_setting_get_name (NM_SETTING (setting))), secrets);
+	dbus_g_method_return (info->context, settings_hash);
+	g_hash_table_destroy (settings_hash);
+
+	/* Save the connection back to GConf _after_ hashing it, because
+	 * saving to GConf might trigger the GConf change notifiers, resulting
+	 * in the connection being read back in from GConf which clears secrets.
+	 */
+	gconf_connection = nma_gconf_settings_get_by_connection (info->applet->gconf_settings, info->connection);
+	if (gconf_connection)
+		nma_gconf_connection_save (gconf_connection);
+
+ done:
+	if (err) {
+		g_warning ("%s", err->message);
+		dbus_g_method_return_error (info->context, err);
+		g_error_free (err);
+	}
+
+	nm_connection_clear_secrets (info->connection);
+	destroy_modem_dialog (info, NULL);
+}
+
+static GtkWidget *
+ask_for_password (NMDevice *device,
+                  NMConnection *connection,
+                  GtkEntry **out_secret_entry)
+{
+	GtkDialog *dialog;
+	GtkWidget *w;
+	GtkBox *box;
+	char *dev_str;
+	NMSettingConnection *s_con;
+	char *tmp;
+	const char *id;
+
+	dialog = GTK_DIALOG (gtk_dialog_new ());
+	gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
+	gtk_window_set_title (GTK_WINDOW (dialog), _("Dial-up Modem password"));
+
+	w = gtk_dialog_add_button (dialog, GTK_STOCK_CANCEL, GTK_RESPONSE_REJECT);
+	w = gtk_dialog_add_button (dialog, GTK_STOCK_OK, GTK_RESPONSE_OK);
+	gtk_window_set_default (GTK_WINDOW (dialog), w);
+
+	s_con = NM_SETTING_CONNECTION (nm_connection_get_setting (connection, NM_TYPE_SETTING_CONNECTION));
+	id = nm_setting_connection_get_id (s_con);
+	g_assert (id);
+	tmp = g_strdup_printf (_("A password is required to connect to '%s'."), id);
+	w = gtk_label_new (tmp);
+	g_free (tmp);
+	gtk_box_pack_start (GTK_BOX (dialog->vbox), w, TRUE, TRUE, 0);
+
+	dev_str = g_strdup_printf ("<b>%s</b>", utils_get_device_description (device));
+	w = gtk_label_new (NULL);
+	gtk_label_set_markup (GTK_LABEL (w), dev_str);
+	g_free (dev_str);
+	gtk_box_pack_start (GTK_BOX (dialog->vbox), w, TRUE, TRUE, 0);
+
+	w = gtk_alignment_new (0.5, 0.5, 0, 1.0);
+	gtk_box_pack_start (GTK_BOX (dialog->vbox), w, TRUE, TRUE, 0);
+
+	box = GTK_BOX (gtk_hbox_new (FALSE, 6));
+	gtk_container_set_border_width (GTK_CONTAINER (box), 6);
+	gtk_container_add (GTK_CONTAINER (w), GTK_WIDGET (box));
+
+	gtk_box_pack_start (box, gtk_label_new (_("Password:")), FALSE, FALSE, 0);
+
+	w = gtk_entry_new ();
+	*out_secret_entry = GTK_ENTRY (w);
+	gtk_entry_set_activates_default (GTK_ENTRY (w), TRUE);
+	gtk_box_pack_start (box, w, FALSE, FALSE, 0);
+
+	gtk_widget_show_all (dialog->vbox);
+	return GTK_WIDGET (dialog);
+}
+
+static gboolean
+modem_get_secrets (NMDevice *device,
+                 NMConnection *connection,
+                 NMActiveConnection *active_connection,
+                 const char *setting_name,
+                 const char **hints,
+                 DBusGMethodInvocation *context,
+                 NMApplet *applet,
+                 GError **error)
+{
+	NMModemInfo *info;
+	GtkWidget *widget;
+	GtkEntry *secret_entry = NULL;
+
+	if (!hints || !g_strv_length ((char **) hints)) {
+		g_set_error (error, NM_SETTINGS_ERROR, NM_SETTINGS_ERROR_INTERNAL_ERROR,
+		             "%s.%d (%s): missing secrets hints.",
+		             __FILE__, __LINE__, __func__);
+		return FALSE;
+	}
+
+	if (!strcmp (hints[0], NM_SETTING_ANALOG_MODEM_PASSWORD))
+		widget = ask_for_password (device, connection, &secret_entry);
+	else {
+		g_set_error (error, NM_SETTINGS_ERROR, NM_SETTINGS_ERROR_INTERNAL_ERROR,
+		             "%s.%d (%s): unknown secrets hint '%s'.",
+		             __FILE__, __LINE__, __func__, hints[0]);
+		return FALSE;
+	}
+
+	if (!widget || !secret_entry) {
+		g_set_error (error, NM_SETTINGS_ERROR, NM_SETTINGS_ERROR_INTERNAL_ERROR,
+		             "%s.%d (%s): error asking for modem secrets.",
+		             __FILE__, __LINE__, __func__);
+		return FALSE;
+	}
+
+	info = g_new (NMModemInfo, 1);
+	info->context = context;
+	info->applet = applet;
+	info->active_connection = active_connection;
+	info->connection = g_object_ref (connection);
+	info->secret_name = g_strdup (hints[0]);
+	info->dialog = widget;
+	info->secret_entry = secret_entry;
+
+	g_signal_connect (widget, "response", G_CALLBACK (get_modem_secrets_cb), info);
+
+	/* Attach a destroy notifier to the NMActiveConnection so we can destroy
+	 * the dialog when the active connection goes away.
+	 */
+	g_object_weak_ref (G_OBJECT (active_connection), destroy_modem_dialog, info);
+
+	gtk_window_set_position (GTK_WINDOW (widget), GTK_WIN_POS_CENTER_ALWAYS);
+	gtk_widget_realize (GTK_WIDGET (widget));
+	gtk_window_present (GTK_WINDOW (widget));
+
+	return TRUE;
+}
+
+NMADeviceClass *
+applet_device_modem_get_class (NMApplet *applet)
+{
+	NMADeviceClass *dclass;
+
+	dclass = g_slice_new0 (NMADeviceClass);
+	if (!dclass)
+		return NULL;
+
+	dclass->new_auto_connection = modem_new_auto_connection;
+	dclass->add_menu_item = modem_add_menu_item;
+	dclass->device_state_changed = modem_device_state_changed;
+	dclass->get_icon = modem_get_icon;
+	dclass->get_secrets = modem_get_secrets;
+
+	return dclass;
+}
+
diff --git a/src/applet-device-modem.h b/src/applet-device-modem.h
new file mode 100644
index 0000000..6f654c8
--- /dev/null
+++ b/src/applet-device-modem.h
@@ -0,0 +1,31 @@
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* NetworkManager Wireless Applet -- Display wireless access points and allow user control
+ *
+ * Dan Williams <dcbw@redhat.com>
+ * Hans Petter Jansson <hpj@novell.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * (C) Copyright 2008 Red Hat, Inc.
+ */
+
+#ifndef __APPLET_DEVICE_MODEM_H__
+#define __APPLET_DEVICE_MODEM_H__
+
+#include "applet.h"
+
+NMADeviceClass *applet_device_modem_get_class (NMApplet *applet);
+
+#endif /* __APPLET_DEVICE_MODEM_H__ */
diff --git a/src/applet-dialogs.c b/src/applet-dialogs.c
index e1dc530..de55a7b 100644
--- a/src/applet-dialogs.c
+++ b/src/applet-dialogs.c
@@ -26,6 +26,7 @@
 
 #include <nm-device-ethernet.h>
 #include <nm-device-wifi.h>
+#include <nm-device-analog-modem.h>
 #include <nm-gsm-device.h>
 #include <nm-cdma-device.h>
 
@@ -262,6 +263,8 @@ info_dialog_add_page (GtkNotebook *notebook,
 		str = g_strdup_printf (_("GSM (%s)"), iface);
 	else if (NM_IS_CDMA_DEVICE (device))
 		str = g_strdup_printf (_("CDMA (%s)"), iface);
+	else if (NM_IS_DEVICE_ANALOG_MODEM (device))
+		str = g_strdup_printf (_("Modem (%s)"), iface);
 	else
 		str = g_strdup (iface);
 
diff --git a/src/applet-polkit-manager.c b/src/applet-polkit-manager.c
index 425d898..42e1282 100644
--- a/src/applet-polkit-manager.c
+++ b/src/applet-polkit-manager.c
@@ -17,6 +17,7 @@
 #include <nm-setting-ppp.h>
 #include <nm-setting-gsm.h>
 #include <nm-setting-cdma.h>
+#include <nm-setting-analog-modem.h>
 
 #include "applet.h"
 #include "applet-polkit-manager.h"
@@ -27,12 +28,14 @@
 #define NM_POLICY_ACTION_USER_MOBILE_APPLY "org.freedesktop.network-manager-settings.user.mobile.apply"
 #define NM_POLICY_ACTION_USER_VPN_APPLY "org.freedesktop.network-manager-settings.user.vpn.apply"
 #define NM_POLICY_ACTION_USER_DSL_APPLY "org.freedesktop.network-manager-settings.user.dsl.apply"
+#define NM_POLICY_ACTION_USER_MODEM_APPLY "org.freedesktop.network-manager-settings.user.modem.apply" // Analog modem
 
 #define NM_POLICY_ACTION_USER_WIRED_APPLY_WITH_SHARE "org.freedesktop.network-manager-settings.user.wired.apply-with-share"
 #define NM_POLICY_ACTION_USER_WIRELESS_APPLY_WITH_SHARE "org.freedesktop.network-manager-settings.user.wireless.apply-with-share"
 #define NM_POLICY_ACTION_USER_MOBILE_APPLY_WITH_SHARE "org.freedesktop.network-manager-settings.user.mobile.apply-with-share"
 #define NM_POLICY_ACTION_USER_VPN_APPLY_WITH_SHARE "org.freedesktop.network-manager-settings.user.vpn.apply-with-share"
 #define NM_POLICY_ACTION_USER_DSL_APPLY_WITH_SHARE "org.freedesktop.network-manager-settings.user.dsl.apply-with-share"
+#define NM_POLICY_ACTION_USER_MODEM_APPLY_WITH_SHARE "org.freedesktop.network-manager-settings.user.modem.apply-with-share" // Analog modem
 
 static AppletPolKitManager *singleton = NULL;
 
@@ -44,12 +47,14 @@ struct _AppletPolKitManagerPriv {
     PolKitAction *user_mobile_apply;
     PolKitAction *user_vpn_apply;
     PolKitAction *user_dsl_apply;
+    PolKitAction *user_modem_apply;
 
     PolKitAction *user_wired_apply_with_share;
     PolKitAction *user_wireless_apply_with_share;
     PolKitAction *user_mobile_apply_with_share;
     PolKitAction *user_vpn_apply_with_share;
     PolKitAction *user_dsl_apply_with_share;
+    PolKitAction *user_modem_apply_with_share;
 };
 
 #define APPLET_POLKIT_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), APPLET_TYPE_POLKIT_MANAGER, AppletPolKitManagerPriv))
@@ -161,6 +166,9 @@ applet_polkit_manager_create_action (AppletPolKitManager * manager, const char *
                     || !strcmp(action_id, NM_SETTING_GSM_SETTING_NAME)) {
                 action_name = "user_mobile_apply";
                 pk_action = priv->user_mobile_apply;
+			} else if (!strcmp(action_id, NM_SETTING_ANALOG_MODEM_SETTING_NAME)) {
+                action_name = "user_modem_apply";
+                pk_action = priv->user_modem_apply;
             } else {
                 g_warning ("Can not create the action(%s). Maybe there is a new policy to be add",
                                                action_id);
@@ -185,6 +193,9 @@ applet_polkit_manager_create_action (AppletPolKitManager * manager, const char *
                     || !strcmp(action_id, NM_SETTING_GSM_SETTING_NAME)) {
                 action_name = "user_mobile_apply_with_share";
                 pk_action = priv->user_mobile_apply_with_share;
+			} else if (!strcmp(action_id, NM_SETTING_ANALOG_MODEM_SETTING_NAME)) {
+                action_name = "user_modem_apply_with_share";
+                pk_action = priv->user_modem_apply_with_share;
             } else {
                 g_warning ("Can not create the action(%s). Maybe there is a new policy to be add",
                                                action_id);
@@ -254,6 +265,8 @@ applet_polkit_manager_init (AppletPolKitManager * manager)
     polkit_action_set_action_id (priv->user_vpn_apply, NM_POLICY_ACTION_USER_VPN_APPLY);
     priv->user_dsl_apply = polkit_action_new ();
     polkit_action_set_action_id (priv->user_dsl_apply, NM_POLICY_ACTION_USER_DSL_APPLY);
+    priv->user_modem_apply = polkit_action_new ();
+    polkit_action_set_action_id (priv->user_modem_apply, NM_POLICY_ACTION_USER_MODEM_APPLY);
 
     /* shared connection */
     priv->user_wired_apply_with_share = polkit_action_new ();
@@ -266,6 +279,8 @@ applet_polkit_manager_init (AppletPolKitManager * manager)
     polkit_action_set_action_id (priv->user_vpn_apply_with_share, NM_POLICY_ACTION_USER_VPN_APPLY_WITH_SHARE);
     priv->user_dsl_apply_with_share = polkit_action_new ();
     polkit_action_set_action_id (priv->user_dsl_apply_with_share, NM_POLICY_ACTION_USER_DSL_APPLY_WITH_SHARE);
+    priv->user_modem_apply_with_share = polkit_action_new ();
+    polkit_action_set_action_id (priv->user_modem_apply_with_share, NM_POLICY_ACTION_USER_MODEM_APPLY_WITH_SHARE);
 
 }
 
@@ -294,6 +309,9 @@ finalize (GObject *gobject)
     if (priv->user_dsl_apply) {
         polkit_action_unref (priv->user_dsl_apply);
     }
+    if (priv->user_modem_apply) {
+        polkit_action_unref (priv->user_modem_apply);
+    }
     /* shared connectin */
     if (priv->user_wired_apply_with_share) {
         polkit_action_unref (priv->user_wired_apply_with_share);
@@ -310,6 +328,9 @@ finalize (GObject *gobject)
     if (priv->user_dsl_apply_with_share) {
         polkit_action_unref (priv->user_dsl_apply_with_share);
     }
+    if (priv->user_modem_apply_with_share) {
+        polkit_action_unref (priv->user_modem_apply_with_share);
+    }
 
     G_OBJECT_CLASS (applet_polkit_manager_parent_class)->finalize (gobject);
 }
